/////////////////////////////////////////////////////////
// Auto-generated by gen_rfnoc_inst.py! Any changes
// in this file will be overwritten the next time
// this script is run.
/////////////////////////////////////////////////////////
localparam NUM_CE = 4;
wire [NUM_CE*64-1:0] ce_flat_o_tdata, ce_flat_i_tdata;
wire [63:0]          ce_o_tdata[0:NUM_CE-1], ce_i_tdata[0:NUM_CE-1];
wire [NUM_CE-1:0]    ce_o_tlast, ce_o_tvalid, ce_o_tready, ce_i_tlast, ce_i_tvalid, ce_i_tready;
wire [63:0]          ce_debug[0:NUM_CE-1];

//PR freeze
wire        ce_o_tready_tmp, ce_i_tlast_tmp, ce_i_tvalid_tmp;
wire [63:0] ce_i_tdata_tmp, ce_debug_tmp;

// Flattern CE tdata arrays
genvar k;
generate
  for (k = 0; k < NUM_CE; k = k + 1) begin
    assign ce_o_tdata[k] = ce_flat_o_tdata[k*64+63:k*64];
    assign ce_flat_i_tdata[k*64+63:k*64] = ce_i_tdata[k];
  end
endgenerate
wire ce_clk = radio_clk;
wire ce_rst = radio_rst;

noc_block_gain  inst_gain (
  .bus_clk(bus_clk), .bus_rst(bus_rst),
  .ce_clk(ce_clk), .ce_rst(ce_rst),
  .i_tdata(ce_o_tdata[0]), .i_tlast(ce_o_tlast[0]), .i_tvalid(ce_o_tvalid[0]), .i_tready(ce_o_tready_tmp),
  .o_tdata(ce_i_tdata_tmp), .o_tlast(ce_i_tlast_tmp), .o_tvalid(ce_i_tvalid_tmp), .o_tready(ce_i_tready[0]),
  .debug(ce_debug_tmp)
);

// isolate output signal
assign ce_o_tready[0] = (freeze)?   1'b0: ce_o_tready_tmp;
assign ce_i_tdata[0] = (freeze)?   64'd0: ce_i_tdata_tmp;
assign ce_i_tlast[0] = (freeze)?   1'b0: ce_i_tlast_tmp;
assign ce_i_tvalid[0] = (freeze)?   1'b0: ce_i_tvalid_tmp;
assign ce_debug[0] = (freeze)?   64'd0: ce_debug_tmp;

noc_block_siggen  inst_siggen (
  .bus_clk(bus_clk), .bus_rst(bus_rst),
  .ce_clk(ce_clk), .ce_rst(ce_rst),
  .i_tdata(ce_o_tdata[1]), .i_tlast(ce_o_tlast[1]), .i_tvalid(ce_o_tvalid[1]), .i_tready(ce_o_tready[1]),
  .o_tdata(ce_i_tdata[1]), .o_tlast(ce_i_tlast[1]), .o_tvalid(ce_i_tvalid[1]), .o_tready(ce_i_tready[1]),
  .debug(ce_debug[1])
);

// Fill remaining crossbar ports with loopback FIFOs
genvar n;
generate
  for (n = 2; n < NUM_CE; n = n + 1) begin
    noc_block_axi_fifo_loopback inst_noc_block_axi_fifo_loopback (
      .bus_clk(bus_clk), .bus_rst(bus_rst),
      .ce_clk(ce_clk), .ce_rst(ce_rst),
      .i_tdata(ce_o_tdata[n]), .i_tlast(ce_o_tlast[n]), .i_tvalid(ce_o_tvalid[n]), .i_tready(ce_o_tready[n]),
      .o_tdata(ce_i_tdata[n]), .o_tlast(ce_i_tlast[n]), .o_tvalid(ce_i_tvalid[n]), .o_tready(ce_i_tready[n]),
      .debug(ce_debug[n])
    );
  end
endgenerate
